VTK: vtkAxisExtended Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkAxisExtended Class Reference

extended axis tick positioning More...

`#include <vtkAxisExtended.h>`

Inheritance diagram for vtkAxisExtended:
[legend]
Collaboration diagram for vtkAxisExtended:
[legend]

## Public Types
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkAxisExtended * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
vtkVector3d | GenerateExtendedTickLabels (double dmin, double dmax, double m, double scaling)
| This method implements the algorithm given in the paper The method return the minimum tick position, maximum tick position and the tick spacing. More...
virtual int | GetDesiredFontSize ()
virtual void | SetDesiredFontSize (int)
virtual int | GetPrecision ()
virtual void | SetPrecision (int)
virtual int | GetLabelFormat ()
virtual void | SetLabelFormat (int)
virtual int | GetOrientation ()
virtual void | SetOrientation (int)
virtual bool | GetIsAxisVertical ()
virtual void | SetIsAxisVertical (bool)
virtual int | GetFontSize ()
| Set/Get methods for variables. More...
virtual void | SetFontSize (int)
| Set/Get methods for variables. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkTypeBool | IsTypeOf (const char *type)
static vtkAxisExtended * | SafeDownCast (vtkObjectBase *o)
static vtkAxisExtended * | New ()
static double | Simplicity (int qIndex, int qLength, int j, double lmin, double lmax, double lstep)
| This method return a value to make step sizes corresponding to low q and j values more preferable. More...
static double | SimplicityMax (int qIndex, int qLength, int j)
| This method returns the maximum possible value of simplicity value given q and j. More...
static double | Coverage (double dmin, double dmax, double lmin, double lmax)
| This method makes the data range approximately same as the labeling range more preferable. More...
static double | CoverageMax (double dmin, double dmax, double span)
| This gives the maximum possible value of coverage given the step size. More...
static double | Density (int k, double m, double dmin, double dmax, double lmin, double lmax)
| This method return a value to make the density of the labels close to the user given value. More...
static double | DensityMax (int k, double m)
| Derives the maximum values for density given k (number of ticks) and m (user given) More...
static double | FormatLegibilityScore (double n, int format)
| This methods return the legibility score of different formats. More...
static int | FormatStringLength (int format, double n, int precision)
| This method returns the string length of different format notations. More...
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkAxisExtended ()
| ~vtkAxisExtended () override
double | Legibility (double lmin, double lmax, double lstep, double scaling, vtkVector< int, 3 > &parameters)
| This method implements an exhaustive search of the legibilty parameters. More...
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
int | Orientation
int | FontSize
int | DesiredFontSize
int | Precision
int | LabelFormat
bool | LabelLegibilityChanged
bool | IsAxisVertical
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

extended axis tick positioning

This implements the optimization based tick position calculating algorithm in the paper "An Extension of Wilkinson's Algorithm for Positioning Tick Labels on Axes" by Junstin Talbot, Sharon Lin and Pat Hanrahan

See also
  vtkAxis

Definition at line 25 of file vtkAxisExtended.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkObject vtkAxisExtended::Superclass

Definition at line 28 of file vtkAxisExtended.h.

## Constructor & Destructor Documentation

## ◆ vtkAxisExtended()

vtkAxisExtended::vtkAxisExtended | ( |  | ) |
| protected

## ◆ ~vtkAxisExtended()

vtkAxisExtended::~vtkAxisExtended | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ IsTypeOf()

static vtkTypeBool vtkAxisExtended::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkAxisExtended::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkObjectBase.

## ◆ SafeDownCast()

static vtkAxisExtended* vtkAxisExtended::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkAxisExtended::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

## ◆ NewInstance()

vtkAxisExtended* vtkAxisExtended::NewInstance | ( |  | ) | const

## ◆ New()

static vtkAxisExtended* vtkAxisExtended::New | ( |  | ) |
| static

## ◆ PrintSelf()

void vtkAxisExtended::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkObjectBase.

## ◆ Simplicity()

static double vtkAxisExtended::Simplicity | ( | int | qIndex,
|  | int | qLength,
|  | int | j,
|  | double | lmin,
|  | double | lmax,
|  | double | lstep
| ) |  |
| static

This method return a value to make step sizes corresponding to low q and j values more preferable.

## ◆ SimplicityMax()

static double vtkAxisExtended::SimplicityMax | ( | int | qIndex,
|  | int | qLength,
|  | int | j
| ) |  |
| static

This method returns the maximum possible value of simplicity value given q and j.

## ◆ Coverage()

static double vtkAxisExtended::Coverage | ( | double | dmin,
|  | double | dmax,
|  | double | lmin,
|  | double | lmax
| ) |  |
| static

This method makes the data range approximately same as the labeling range more preferable.

## ◆ CoverageMax()

static double vtkAxisExtended::CoverageMax | ( | double | dmin,
|  | double | dmax,
|  | double | span
| ) |  |
| static

This gives the maximum possible value of coverage given the step size.

## ◆ Density()

static double vtkAxisExtended::Density | ( | int | k,
|  | double | m,
|  | double | dmin,
|  | double | dmax,
|  | double | lmin,
|  | double | lmax
| ) |  |
| static

This method return a value to make the density of the labels close to the user given value.

## ◆ DensityMax()

static double vtkAxisExtended::DensityMax | ( | int | k,
|  | double | m
| ) |  |
| static

Derives the maximum values for density given k (number of ticks) and m (user given)

## ◆ FormatLegibilityScore()

static double vtkAxisExtended::FormatLegibilityScore | ( | double | n,
|  | int | format
| ) |  |
| static

This methods return the legibility score of different formats.

## ◆ FormatStringLength()

static int vtkAxisExtended::FormatStringLength | ( | int | format,
|  | double | n,
|  | int | precision
| ) |  |
| static

This method returns the string length of different format notations.

## ◆ GenerateExtendedTickLabels()

vtkVector3d vtkAxisExtended::GenerateExtendedTickLabels | ( | double | dmin,
|  | double | dmax,
|  | double | m,
|  | double | scaling
| ) |  |

This method implements the algorithm given in the paper The method return the minimum tick position, maximum tick position and the tick spacing.

## ◆ GetFontSize()

virtual int vtkAxisExtended::GetFontSize | ( |  | ) |
| virtual

Set/Get methods for variables.

## ◆ SetFontSize()

virtual void vtkAxisExtended::SetFontSize | ( | int |  | ) |
| virtual

Set/Get methods for variables.

## ◆ GetDesiredFontSize()

virtual int vtkAxisExtended::GetDesiredFontSize | ( |  | ) |
| virtual

## ◆ SetDesiredFontSize()

virtual void vtkAxisExtended::SetDesiredFontSize | ( | int |  | ) |
| virtual

## ◆ GetPrecision()

virtual int vtkAxisExtended::GetPrecision | ( |  | ) |
| virtual

## ◆ SetPrecision()

virtual void vtkAxisExtended::SetPrecision | ( | int |  | ) |
| virtual

## ◆ GetLabelFormat()

virtual int vtkAxisExtended::GetLabelFormat | ( |  | ) |
| virtual

## ◆ SetLabelFormat()

virtual void vtkAxisExtended::SetLabelFormat | ( | int |  | ) |
| virtual

## ◆ GetOrientation()

virtual int vtkAxisExtended::GetOrientation | ( |  | ) |
| virtual

## ◆ SetOrientation()

virtual void vtkAxisExtended::SetOrientation | ( | int |  | ) |
| virtual

## ◆ GetIsAxisVertical()

virtual bool vtkAxisExtended::GetIsAxisVertical | ( |  | ) |
| virtual

## ◆ SetIsAxisVertical()

virtual void vtkAxisExtended::SetIsAxisVertical | ( | bool |  | ) |
| virtual

## ◆ Legibility()

double vtkAxisExtended::Legibility | ( | double | lmin,
|  | double | lmax,
|  | double | lstep,
|  | double | scaling,
|  | vtkVector< int, 3 > & | parameters
| ) |  |
| protected

This method implements an exhaustive search of the legibilty parameters.

## Member Data Documentation

## ◆ Orientation

int vtkAxisExtended::Orientation
| protected

Definition at line 116 of file vtkAxisExtended.h.

## ◆ FontSize

int vtkAxisExtended::FontSize
| protected

Definition at line 117 of file vtkAxisExtended.h.

## ◆ DesiredFontSize

int vtkAxisExtended::DesiredFontSize
| protected

Definition at line 118 of file vtkAxisExtended.h.

## ◆ Precision

int vtkAxisExtended::Precision
| protected

Definition at line 119 of file vtkAxisExtended.h.

## ◆ LabelFormat

int vtkAxisExtended::LabelFormat
| protected

Definition at line 120 of file vtkAxisExtended.h.

## ◆ LabelLegibilityChanged

bool vtkAxisExtended::LabelLegibilityChanged
| protected

Definition at line 121 of file vtkAxisExtended.h.

## ◆ IsAxisVertical

bool vtkAxisExtended::IsAxisVertical
| protected

Definition at line 122 of file vtkAxisExtended.h.

The documentation for this class was generated from the following file:

- Charts/Core/vtkAxisExtended.h